import { IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class FillImageModel extends BaseModel {
    meter2coord: number;
    private texture;
    private isMeter;
    private radian;
    getUninforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(): IModel[];
    /**
     * 计算等面积点图层（unit meter）笛卡尔坐标标度与世界坐标标度的比例
     * @returns
     */
    calMeter2Coord(): void;
    buildModels(): IModel[];
    getShaders(): {
        frag: string;
        vert: string;
        type: string;
    };
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private updateTexture;
}
