"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _l7Core = require("@antv/l7-core");

var _l7Maps = require("@antv/l7-maps");

var _BaseModel2 = _interopRequireDefault(require("../../core/BaseModel"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var spriteFrag = "\nuniform sampler2D u_texture;\nuniform float u_mapFlag;\nuniform float u_opacity;\n\nvarying vec3 v_Color;\nvarying float v_d;\n\n#pragma include \"picking\"\nvoid main() {\n\n  if(v_d < 0.0) {\n    discard;\n  }\n\n  if(u_mapFlag > 0.0) {\n    gl_FragColor = texture2D(u_texture, gl_PointCoord);\n    gl_FragColor.a *= u_opacity;\n  } else {\n    gl_FragColor = vec4(v_Color, u_opacity);\n  }\n\n  gl_FragColor = filterColor(gl_FragColor);\n}\n";
var spriteVert = "precision highp float;\n\nattribute vec3 a_Position;\nattribute vec3 a_Color;\n\nuniform mat4 u_ModelMatrix;\nuniform mat4 u_Mvp;\nuniform float u_opacity;\nuniform float u_Scale;\nvarying vec3 v_Color;\nvarying float v_d;\n\n#pragma include \"projection\"\n#pragma include \"picking\"\nvoid main() {\n   v_Color = a_Color;\n  \n   vec4 project_pos = project_position(vec4(a_Position, 1.0));\n\n   v_d = a_Position.z;\n\n   if(u_CoordinateSystem == COORDINATE_SYSTEM_P20_2) { // gaode2.x\n      gl_Position = u_Mvp * (vec4(project_pos.xy, a_Position.z, 1.0));\n   } else {\n      gl_Position = project_common_position_to_clipspace(vec4(project_pos.xy, a_Position.z, 1.0));\n   }\n\n   gl_PointSize = pow((u_Zoom - 1.0), 2.0) * u_Scale;\n\n   setPickingColor(a_PickingColor);\n}\n";
var SPRITE_ANIMATE_DIR;

(function (SPRITE_ANIMATE_DIR) {
  SPRITE_ANIMATE_DIR["UP"] = "up";
  SPRITE_ANIMATE_DIR["DOWN"] = "down";
})(SPRITE_ANIMATE_DIR || (SPRITE_ANIMATE_DIR = {}));

var SpriteModel = function (_BaseModel) {
  (0, _inherits2.default)(SpriteModel, _BaseModel);

  var _super = _createSuper(SpriteModel);

  function SpriteModel() {
    var _this;

    (0, _classCallCheck2.default)(this, SpriteModel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "texture", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "mapTexture", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "positions", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "indices", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "timer", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "spriteTop", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "spriteUpdate", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "spriteAnimate", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "planeGeometryUpdateTriangulation", function () {
      var updateZ = _this.spriteUpdate;
      var bottomZ = -100000;
      var topZ = _this.spriteTop;

      for (var i = 0; i < _this.positions.length; i += 5) {
        if (_this.spriteAnimate === SPRITE_ANIMATE_DIR.UP) {
          _this.positions[i + 2] += updateZ;

          if (_this.positions[i + 2] > topZ) {
            _this.positions[i + 2] = bottomZ;
          }
        } else {
          _this.positions[i + 2] -= updateZ;

          if (_this.positions[i + 2] < bottomZ) {
            _this.positions[i + 2] = topZ;
          }
        }
      }

      return {
        vertices: _this.positions,
        indices: _this.indices,
        size: 5
      };
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "updateModel", function () {
      var attributes = _this.layer.createAttrubutes({
        triangulation: _this.planeGeometryUpdateTriangulation
      });

      _this.layer.models.map(function (m) {
        m.updateAttributes(attributes);
      });

      _this.layer.renderLayers();

      _this.timer = requestAnimationFrame(_this.updateModel);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "planeGeometryTriangulation", function () {
      var _this2;

      var _ref = _this.layer.getLayerConfig(),
          _ref$center = _ref.center,
          center = _ref$center === void 0 ? [120, 30] : _ref$center,
          _ref$spriteCount = _ref.spriteCount,
          spriteCount = _ref$spriteCount === void 0 ? 100 : _ref$spriteCount,
          _ref$spriteRadius = _ref.spriteRadius,
          spriteRadius = _ref$spriteRadius === void 0 ? 10 : _ref$spriteRadius;

      var _this$initSprite = (_this2 = _this).initSprite.apply(_this2, [spriteRadius, spriteCount].concat((0, _toConsumableArray2.default)(center))),
          indices = _this$initSprite.indices,
          positions = _this$initSprite.positions;

      _this.positions = positions;
      _this.indices = indices;
      return {
        vertices: positions,
        indices: indices,
        size: 5
      };
    });
    return _this;
  }

  (0, _createClass2.default)(SpriteModel, [{
    key: "initSprite",
    value: function initSprite() {
      var radius = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
      var spriteCount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
      var lng = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 120;
      var lat = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 30;
      var indices = [];
      var positions = [];
      var mapService = this.mapService;
      var heightLimit = this.spriteAnimate === SPRITE_ANIMATE_DIR.UP ? -this.spriteTop : this.spriteTop;

      for (var i = 0; i < spriteCount; i++) {
        var height = Math.random() * heightLimit;
        positions.push.apply(positions, (0, _toConsumableArray2.default)(getPos(height)));
      }

      for (var _i = 0; _i < spriteCount; _i++) {
        indices.push(_i);
      }

      function getPos(z) {
        var randomX = radius * Math.random();
        var randomY = radius * Math.random();
        var x = -radius / 2 + randomX;
        var y = -radius / 2 + randomY;

        if (mapService.version === _l7Maps.Version['GAODE2.x']) {
          var _ref2 = mapService.lngLatToCoord([x + lng, -y + lat]),
              _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
              a = _ref3[0],
              b = _ref3[1];

          return [a, b, z, 0, 0];
        } else {
          return [x + lng, -y + lat, z, 0, 0];
        }
      }

      return {
        indices: indices,
        positions: positions
      };
    }
  }, {
    key: "getUninforms",
    value: function getUninforms() {
      var _ref4 = this.layer.getLayerConfig(),
          opacity = _ref4.opacity,
          mapTexture = _ref4.mapTexture,
          _ref4$spriteScale = _ref4.spriteScale,
          spriteScale = _ref4$spriteScale === void 0 ? 1 : _ref4$spriteScale;

      if (this.mapTexture !== mapTexture) {
        var _this$texture;

        this.mapTexture = mapTexture;
        (_this$texture = this.texture) === null || _this$texture === void 0 ? void 0 : _this$texture.destroy();
        this.updateTexture(mapTexture);
      }

      return {
        u_opacity: opacity || 1,
        u_mapFlag: mapTexture ? 1 : 0,
        u_texture: this.texture,
        u_Scale: spriteScale
      };
    }
  }, {
    key: "clearModels",
    value: function clearModels() {
      var _this$texture2;

      cancelAnimationFrame(this.timer);
      (_this$texture2 = this.texture) === null || _this$texture2 === void 0 ? void 0 : _this$texture2.destroy();
    }
  }, {
    key: "initModels",
    value: function initModels() {
      var _this3 = this;

      var _ref5 = this.layer.getLayerConfig(),
          mapTexture = _ref5.mapTexture,
          _ref5$spriteTop = _ref5.spriteTop,
          spriteTop = _ref5$spriteTop === void 0 ? 5000000 : _ref5$spriteTop,
          _ref5$spriteUpdate = _ref5.spriteUpdate,
          spriteUpdate = _ref5$spriteUpdate === void 0 ? 10000 : _ref5$spriteUpdate,
          _ref5$spriteAnimate = _ref5.spriteAnimate,
          spriteAnimate = _ref5$spriteAnimate === void 0 ? SPRITE_ANIMATE_DIR.DOWN : _ref5$spriteAnimate;

      this.mapTexture = mapTexture;
      this.spriteTop = spriteTop;
      this.spriteUpdate = spriteUpdate;
      spriteAnimate === 'up' ? this.spriteAnimate = SPRITE_ANIMATE_DIR.UP : this.spriteAnimate = SPRITE_ANIMATE_DIR.DOWN;
      var createTexture2D = this.rendererService.createTexture2D;
      this.texture = createTexture2D({
        height: 0,
        width: 0
      });
      this.updateTexture(mapTexture);
      setTimeout(function () {
        _this3.updateModel();
      }, 100);
      return [this.layer.buildLayerModel({
        moduleName: 'geometry_sprite',
        vertexShader: spriteVert,
        fragmentShader: spriteFrag,
        triangulation: this.planeGeometryTriangulation,
        primitive: _l7Core.gl.POINTS,
        depth: {
          enable: false
        },
        blend: this.getBlend()
      })];
    }
  }, {
    key: "buildModels",
    value: function buildModels() {
      return this.initModels();
    }
  }, {
    key: "updateTexture",
    value: function updateTexture(mapTexture) {
      var _this4 = this;

      var createTexture2D = this.rendererService.createTexture2D;

      if (mapTexture) {
        var img = new Image();
        img.crossOrigin = 'anonymous';

        img.onload = function () {
          _this4.texture = createTexture2D({
            data: img,
            width: img.width,
            height: img.height,
            wrapS: _l7Core.gl.CLAMP_TO_EDGE,
            wrapT: _l7Core.gl.CLAMP_TO_EDGE
          });

          _this4.layerService.updateLayerRenderList();

          _this4.layerService.renderLayers();
        };

        img.src = mapTexture;
      } else {
        this.texture = createTexture2D({
          width: 0,
          height: 0
        });
      }
    }
  }, {
    key: "getConfigSchema",
    value: function getConfigSchema() {
      return {
        properties: {
          opacity: {
            type: 'number',
            minimum: 0,
            maximum: 1
          }
        }
      };
    }
  }, {
    key: "registerBuiltinAttributes",
    value: function registerBuiltinAttributes() {
      return '';
    }
  }]);
  return SpriteModel;
}(_BaseModel2.default);

exports.default = SpriteModel;
//# sourceMappingURL=sprite.js.map